/*------------------------------------------------------------------------
    File        : SaveCustomers.p
    Purpose     : Simple customer commit service
    Author(s)   : pjudge
    Created     : Tue May 17 09:08:53 EDT 2011
    Notes       : * BusinessEntity, DataAccess and DataSources all rolled into one!
  ----------------------------------------------------------------------*/
routine-level on error undo, throw.

/* ***************************  Definitions  ************************** */
define temp-table ttCustomer no-undo  before-table btCustomer
    field CustNum as integer
    field Name as character
    field CreditLimit as decimal
    field Balance as decimal
    field FullAddress as character
    index idx1 as primary unique CustNum.
    
define dataset dsCustomer for ttCustomer.

define input parameter table for ttCustomer.

/* ***************************  Main Block  *************************** */
define data-source srcCustomer for Customer.

buffer ttCustomer:attach-data-source(data-source srcCustomer:handle).

run SaveData.

buffer ttCustomer:detach-data-source().

procedure SaveData:
    /* use before-table */
    for each btCustomer:
        buffer btCustomer:save-row-changes().
    end.
end procedure.
