/*------------------------------------------------------------------------
    File        : CustomerABLGuiWrapper
    Purpose     : 

    Syntax      :

    Description : 

    Author(s)   : pjudge
    Created     : Wed Jun 08 08:47:39 EDT 2011
    Notes       :
  ----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

routine-level on error undo, throw.

/* ********************  Preprocessor Definitions  ******************** */


/* ***************************  Main Block  *************************** */
class CustomerABLGuiWrapper implements IUserInterface:
        
    define variable mhABLGui as handle no-undo.
    
	define public property EventHandler as IEventHandler no-undo
	   get.
    	set(input arg as IEventHandler):	    
    	    EventHandler = arg.	    
    	    if valid-handle(mhABLGui) then
    	       run SetEventHandler in mhABLGui (arg).
    	end set.

    constructor public CustomerABLGuiWrapper():
        run customer_abl_gui.p persistent set mhABLGui.
    end constructor.

    destructor public CustomerABLGuiWrapper():
        delete object mhABLGui no-error.
    end destructor.
    
	method public void BeginWaitFor( input pcShowMode as character ):
	    run BeginWaitFor in mhABLGui(pcShowMode).
	end method.

	method public void Destroy():
	    run Destroy in mhABLGui.
	end method.

	method public void EndWaitFor():
	    run EndWaitFor in mhABLGui.
	end method.

	method public character extent GetScreenValue( input pcFieldName as character extent ):
	    define variable cFieldValue as character extent no-undo.
	    
	    run GetScreenValue in mhABLGui(input pcFieldName, output cFieldValue). 
		
        return cFieldValue.
	end method.

	method public void HideUI(  ):
	    run HideUI in mhABLGui.
	end method.

	method public void Initialise():
	    run Initialise in mhABLGui.
	end method.

	method public void SetNavPanelState( input plEnabled as logical extent ):
	    run SetNavPanelState in mhABLGui (input plEnabled).
	end method.

	method public void ShowRecord(  ):
	    run ShowRecord in mhABLGui.
	end method.

	method public void ShowUI():
	    run ShowUI in mhABLGui.
	end method.

end class.