/*------------------------------------------------------------------------
    File        : CustomerWebUI
    Purpose     : 

    Syntax      :

    Description : 

    Author(s)   : pjudge
    Created     : Wed Jun 08 08:47:39 EDT 2011
    Notes       :
  ----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

routine-level on error undo, throw.

/* ********************  Preprocessor Definitions  ******************** */

/* ***************************  Main Block  *************************** */
class CustomerWebUI use-widget-pool implements IUserInterface:
    define variable mhWebHelper as handle no-undo.
    
    define variable mlNavPanelEnabled as logical extent 4 no-undo.
    define variable mcFieldName as character extent 4 no-undo.
    define variable mcFieldValue as character extent 4 no-undo.
    /* PugChallenge11 redirects to */
    define variable mcBaseUrl as character no-undo init '/PugChallenge11/customer_eventhandler_wrapper.p'.
    
    define public property EventHandler as IEventHandler no-undo get. set.

    constructor public CustomerWebUI():
        run webhelper.p persistent set mhWebHelper.
    end constructor.
    
    destructor public CustomerWebUI():
        delete object mhWebHelper no-error.
    end destructor.
    
    method public void BeginWaitFor( input pcShowMode as character ):
        /* no-op in web world; just have the method here for the contract */
    end method.

    method public void EndWaitFor():
        /* no-op in web world */
    end method.

    method public character extent GetScreenValue( input pcFieldName as character extent ):
        define variable cFieldValue as character extent no-undo.
        
        define variable iLoop as integer no-undo.
        define variable iMax as integer no-undo.
        
        iMax = extent(pcFieldName).
        extent(cFieldValue) = iMax.
        do iLoop = 1 to iMax:
            cFieldValue[iLoop] = dynamic-function('get-field' in mhWebHelper, pcFieldName[iLoop]). 
        end.
        
        return cFieldValue.
    end method.

    method public void HideUI(  ):
        /* no-op */
    end method.

    method public void Initialise():
        
    end method.

    method public void Destroy():
        
    end method.

    method public void SetNavPanelState( input plEnabled as logical extent ):
        mlNavPanelEnabled = plEnabled.
    end method.

    method public void ShowRecord(  ):
        /* only the UI knows what data it wants to show */
        assign mcFieldName[1] = 'CustNum'
               mcFieldName[2] = 'FullAddress'
               mcFieldName[3] = 'CreditLimit'
               mcFieldName[4] = 'Balance'.
        
        mcFieldValue = EventHandler:GetDataValue('customer', mcFieldName).
    end method.

    method public void ShowUI():
        define variable cContent as character no-undo.

        dynamic-function('output-content-type' in mhWebHelper, 'text/html').
        
        cContent =          
            '<HTML>
            <HEAD>
            <TITLE>Customer Credit Limit &amp; Balance Detail</TITLE>
            </HEAD>
            <BODY>
            <CENTER>
            <FORM action="' + mcBaseUrl + GetQueryString('') + '" method="POST" name="customer_eventhandler.p">
            <TABLE>
                <TR>
                    <TH>Navigation</TH>
                    <TH />
                    <TH>Update</TH>
                </TR>
                <TR>
                    <TD>
                    <TABLE>
                        <TD>' + GetNavPanelActionHtml('first') + '</TD>
                        <TD>' + GetNavPanelActionHtml('prev') + '</TD>
                        <TD>' + GetNavPanelActionHtml('next') + '</TD>
                        <TD>' + GetNavPanelActionHtml('last') + '</TD>
                    </TABLE>
                    </TD>
                    <TD></TD>
                    <TD>
                    <TABLE>
                        <TD>' + GetUpdatePanelActionHtml('Add') + '</TD>
                        <TD>' + GetUpdatePanelActionHtml('Save') + '</TD>
                        <TD>' + GetUpdatePanelActionHtml('Delete') + '</TD>
                    </TABLE>
                    </TD>
                </TR>
            </TABLE>
            <TABLE>
                <TR>
                    <TD><LABEL for="uxCustNum">Cust Num</LABEL></TD>
                    <TD><INPUT type="text" name="uxCustNum" value="' + mcFieldValue[1] + '"></TD>
                </TR>
                <TR>
                    <TD><LABEL for="uxCreditLimit">Credit Limit</LABEL></TD>
                    <TD><INPUT type="text" name="uxCreditLimit" value="' + mcFieldValue[3] + '"></TD>
                </TR>
                <TR>
                    <TD><LABEL for="uxBalance">Balance</LABEL></TD>
                    <TD><INPUT type="text" name="uxBalance" value="' + mcFieldValue[4] + '"></TD>
                </TR>
                <TR>
                    <TD><LABEL for="uxFullAddress">Full Address</LABEL></TD>
                    <TD><INPUT type="text" name="uxFullAddress" size="75" value="' + mcFieldValue[2] + '"></TD>
                </TR>
            </TABLE>
            </FORM>
            </CENTER>
            </BODY>
            </HTML>'
            .
            
        run StreamHtml in mhWebHelper (cContent).            
    end method.

    method private character GetQueryString(input pcArgs as character):
        define variable cQueryString as character no-undo.
        
        cQueryString = '?' + substitute("CurrentCustNum=&1", mcFieldValue[1])
                     + '&' + left-trim(pcArgs, '&').
        
        return cQueryString.
    end method.
    
    method private character GetNavPanelActionHtml(input pcAction as character):
        define variable cLinkHtml as character no-undo.
        define variable cActions as character no-undo init 'first,prev,next,last'.
            
        if mlNavPanelEnabled[lookup(pcAction, cActions)] then
            cLinkHtml = '<A HREF="' + mcBaseUrl + GetQueryString('&NavPanel=' + pcAction) + '">'
                      + '<IMG SRC="/img/resultset_' + pcAction + '_32x32.png" BORDER="0"></A>'.
        else
            cLinkHtml = '<IMG SRC="/img/resultset_' + pcAction + '_32x32_bw.png" BORDER="0">'.
        
        return cLinkHtml.
    end method.
    
    method private character GetUpdatePanelActionHtml(input pcAction as character):
        define variable cLinkHtml as character no-undo.
        
        cLinkHtml = '<TD><INPUT TYPE="image" SRC="/img/' + pcAction + '_32x32.png" BORDER="0" ALT="' + pcAction + '">'.
        cLinkHtml = '<TD><IMG SRC="/img/' + pcAction + '_32x32_bw.png" BORDER="0" ALT="' + pcAction + '"/>'.
        
        return cLinkHtml.
    end method.
end class.