/*------------------------------------------------------------------------
    File        : IClientData
    Purpose     : 
    Syntax      : 
    Description : 
    Author(s)   : pjudge
    Created     : Wed May 25 16:21:00 EDT 2011
    Notes       : 
  ----------------------------------------------------------------------*/

using Progress.Lang.*.

interface IClientData:
    
    /* A. INIT/DESTROY */
    method public void Initialise().
    method public void Destroy().
    
    method public void FetchData().
    method public void SaveData().

    /* C. BASIC DATA NAVIGATION */
    method public void OpenQuery().
    method public void CloseQuery().
    method public void GetFirst().
    method public void GetPrev().
    method public void GetNext().
    method public void GetLast().

    /* D. DATA INPUT/OUTPUT from UI */
    method public character extent GetDataValue(input pcFieldName as character extent).
    method public void SetValue(input pcFieldName as character extent,
                                input pcValue as character extent).
    method public handle GetQueryHandle().

    /* E. want extra enhancements - filtering, sorting, navigating around result set etc */
    method public void RepositionQuery(input pcFieldName as character,
                                       input pcValue as character).
    
    method public void FilterQuery(input pcFilter as character).
    method public void SortQuery(input pcSort as character).
    
    method public character GetCurrentPosition().
  
end interface.